% function GetHeadData()
rng('shuffle');
% 
% A = load('animal_movement.mat');
% posx = A.posx;
% posy = A.posy;
noisevar = 0;
% noisevar1 = 0.05;
varterm= 0.4;
alpha = 0.3;
dt= 10;
N = 100;
Rmin = 30;
inh = 0.05;
n = 10;
extinp = 1;
dtinv = 10;
tau = 10;
preferencefromsomewhere = (1:N)'*2*pi/(N) - pi  + noisevar * normrnd(0,pi, N,1);
xes = zeros(N,1);
W = zeros(N,N);
for x = 1:N
    xes(x) = x;
end
for x = 1:N
    xdiff = abs(xes -x);
    xdiff = min(xdiff, N-xdiff);
    W(x,xdiff>Rmin) = -inh;
end
% 
% for i = 1:N
%     for j = 1:N
%         diff = abs(preferencefromsomewhere(i)-preferencefromsomewhere(j));
%         diff = min(diff, 2*pi-diff);
%         if (diff > Rmin)
%             W(i,j) = -inh;
%         end
%     end
% end


S = zeros(N,1); %Usual HD
for i = 1:floor(40)
    S(ceil(rand()*(N))) = rand();
end





numStable = 201;
for t = 1:numStable %% let stable pattern form
    S = S + 1./(dtinv+tau) * (-S + max(0., extinp+W*S));
end
% inputs on [-pi, pi) + noisevar

len = length(posx);
Sout = zeros(N,len);
angs = zeros(len, 1);

for t = dt+1:length(posx)-dt
    ang = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    angs(t,:) = ang;
    
    %% Head 1
    dd = ang-preferencefromsomewhere;
    dd(logical(dd>pi)) = dd(logical(dd>pi))-2.*pi;
    dd(dd<-pi) = dd(logical(dd<-pi))+2.*pi;
%     inp = zeros(N,1);
%     for i = 1:N
%         if (abs(dd(i)) < pi/2)
%             inp(i) = alpha * exp( - dd(i).^2 / (2.*varterm) );
%         end
%     end
    inp = alpha * exp( - dd.^2 / (2.*varterm) );
    
    for i = 1:dt
        S = S + 1./(dtinv+tau) * (-S + max(0., extinp + inp +  W*S));
    end
    Sout(:,t) = S(:);
end

neurons = 1;%:20:100;
timesteps = 1:1:size(Sout,2);
figure;
polarplot(angs(timesteps),Sout(neurons,timesteps), '*');

spikes = FiringRateToSpikes(Sout);
S = SmoothSpikes(spikes);

% 
% figure;
% polarplot(angs(timesteps),S(500,timesteps), '*');
