function Sout = SmoothSpikes(Sin)
dev = 15; %10
lenG = 5*dev;%100;
Sout = zeros(size(Sin,1), size(Sin,2)+lenG*2);
x = -lenG:lenG;
norm = normpdf(x, 0, dev);
for i = 1:size(Sin,1)
    spikes = find(Sin(i,:) ==1)+lenG;
    for j = 1:length(spikes)
        Sout(i, spikes(j)-lenG:spikes(j)+lenG) = Sout(i, spikes(j)-lenG:spikes(j)+lenG)+ norm;
    end
end
Sout = Sout(:, lenG+1:end-lenG);
end