function plotEireneAnalysis(lifeSpans, correct, lens)
names = {'dt', 'HD', 'Place', 'TwoDir', 'HeadTwo', 'Poisson', ...
    'remove', 'dimPCA' ,'neuronPoint' ,'euclidDist'};
vals = { {'1:100:10000', '1:10:1000'}, {'25', '50', '75', '100'}, {'0', '25'},{'0', '25'}, {'0','4','8','12','16','20','24','28','32','36','40','44','48',...
    '52','56','60','64','68','72','76','80','84','88', '92', '96', '100'},{'0', '25'} ...
    {'0', '5'},{'3', '10'},{'true', 'false'}, {'true', 'false'}};
inds = {1:lens(1), 1:lens(2), 1:lens(3), 1:lens(4), 1:lens(5), ...
    1:lens(6), 1:lens(7), 1:lens(8), 1:lens(9), 1:lens(10)};
l1 = lifeSpans(:,:,:,:,:,:,:,:,:,:,1);
l1name = 'longest';
l2 = lifeSpans(:,:,:,:,:,:,:,:,:,:,2);
l2name = '2nd longest';
r1 = correct(:,:,:,:,:,:,:,:,:,:,1);
r1name = 'Set 1 max';
r2 = correct(:,:,:,:,:,:,:,:,:,:,2);
r2name = 'Set 2 2nd';
r3 = correct(:,:,:,:,:,:,:,:,:,:,3);
r3name = 'Set 2 max ';
r4 = correct(:,:,:,:,:,:,:,:,:,:,4);
r4name = 'Set 1 2nd';
r5 = correct(:,:,:,:,:,:,:,:,:,:,5);
r5name = 'Set 1 max';
r6 = correct(:,:,:,:,:,:,:,:,:,:,6);
r6name = 'Set 2 2nd';
r7 = correct(:,:,:,:,:,:,:,:,:,:,7);
r7name = 'Set 2 max ';
r8 = correct(:,:,:,:,:,:,:,:,:,:,8);
r8name = 'Set 1 2nd';
p1 = correct(:,:,:,:,:,:,:,:,:,:,9);
p1name = 'Set 1 max';
p2 = correct(:,:,:,:,:,:,:,:,:,:,10);
p2name = 'Set 2 2nd';
p3 = correct(:,:,:,:,:,:,:,:,:,:,11);
p3name = 'Set 1 2nd';
p4 = correct(:,:,:,:,:,:,:,:,:,:,12);
p4name = 'correct 2nd 1';
for i = 3
    name = names{i};
    valnames = vals{i};
    for j = 1:1%lens(i)
        valname = valnames{j};
        xvals = 1:4:400;
        tempinds = inds;
%        tempinds(i) = {j};
        
        %% neuron
        figure
        this1 = l1(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
            tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
        N1 = this1(:);
        N1(logical(N1<0)) = 0;
        plot(xvals,N1);
        hold on
        this2 = l2(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
            tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
        N2 = this2(:);
        N2(logical(N2<0)) = 0;
        plot(xvals,N2);
        
%         title([valname ' Set 1 vs Set 2, 1D PH class max and 2nd Neuron']);
%         legend(l1name, l2name);
        xlabel('N');
        ylabel('life');
        set(findall(gca, 'Type', 'Line'),'LineWidth',2);
        set(gca,'FontSize',20)
        hold off
        
 
        %% neuron
%         figure;
%         this1 = r1(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N1 = this1(:);
%         N1(logical(N1<0)) = 0;        
%         plot(xvals,N1);
%         hold on
%         this2 = r2(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N2 = this2(:);
%         N2(logical(N2<0)) = 0;
%         plot(xvals,N2);
%         hold on
%         this3 = r3(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N3 = this3(:);
%         N3(logical(N3<0)) = 0;
%         plot(xvals,N3);
%         hold on
%         this4 = r4(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N4 = this4(:);
%         N4(logical(N4<0)) = 0;
%         plot(xvals,N4);
        
%         title([valname ' Number of correct points from set 1 and 2 in gen. 1D class Neuron']);
%         xlabel('N');
%         ylabel('# neurons');
%         set(findall(gca, 'Type', 'Line'),'LineWidth',2);
%         set(gca,'FontSize',20)
%        legend(r1name, r2name, r3name, r4name);
%         hold off
        
%             %% neuron
%         figure;
%         this1 = r5(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N1 = this1(:);
%         N1(logical(N1<0)) = 0;        
%         plot(xvals,N1);
%         hold on
%         this2 = r6(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N2 = this2(:);
%         N2(logical(N2<0)) = 0;
%         plot(xvals,N2);
%         hold on
%         this3 = r7(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N3 = this3(:);
%         N3(logical(N3<0)) = 0;
%         plot(xvals,N3);
%         hold on
%         this4 = r8(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N4 = this4(:);
%         N4(logical(N4<0)) = 0;
%         plot(xvals,N4);
%         
%         title([valname ' Number of correct points from set 1 and 2 in 0D class of 1D gen Neuron']);
%         xlabel('N');
%         ylabel('num correct');
%         set(findall(gca, 'Type', 'Line'),'LineWidth',2);
%         set(gca,'FontSize',20)
%         legend(r5name, r6name, r7name, r8name);
%         hold off
        
%         %% neuron
%         figure;
%         this1 = p1(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N1 = this1(:);
%         N1(logical(N1<0)) = 0;        
%         plot(xvals,N1);
%         hold on
%         this2 = p2(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N2 = this2(:);
%         N2(logical(N2<0)) = 0;
%         plot(xvals,N2);
%         hold on
%         this3 = p3(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N3 = this3(:);
%         N3(logical(N3<0)) = 0;
%         plot(xvals,N3);
%         hold on
%         this4 = p4(tempinds{1}, tempinds{2}, tempinds{3}, tempinds{4},  tempinds{5}, ...
%             tempinds{6}, tempinds{7}, tempinds{8}, 1, tempinds{10});
%         N4 = this4(:);
%         N4(logical(N4<0)) = 0;
%         plot(xvals,N4);
        
%         title([valname ' Number of correct points from set 1 and 2 in 0D class max and 2nd Neuron']);
%         xlabel('N');
%         ylabel('num correct');
%         set(findall(gca, 'Type', 'Line'),'LineWidth',2);
%         set(gca,'FontSize',20)
% %         legend(p1name, p2name, p3name, p4name);
%         hold off
    end
end
end