    %https://praneethnamburi.wordpress.com/2015/02/05/simulating-neural-spike-trains/
% function [spikeMat, tVec] = poissonSpikeGen(fr, tSim, nTrials)
% dt = 1/1000; % s
% nBins = floor(tSim/dt);
% spikeMat = rand(nTrials, nBins) < fr*dt;
% tVec = 0:dt:tSim-dt;
 

function [] = plotRaster(spikeMat, tVec)
figure
hold all;
for trialCount = 1:size(spikeMat,1)
    spikePos = tVec(spikeMat(trialCount, :));
    for spikeCount = 1:length(spikePos)
        plot([spikePos(spikeCount) spikePos(spikeCount)], ...
            [trialCount-0.4 trialCount+0.4], 'k');
    end
end
ylim([0 size(spikeMat, 1)+1]);
xlabel('Time (ms)');
ylabel('Neuron');
end