function plot_betti_curve(dims, births, deaths)
maxD = max(dims(:));
maxc = 0;
for i = 0:maxD
    d = deaths(logical(dims == i | dims == -1-i));
    btemp = births(logical(dims == i | dims == -1-i));
    [d1, I] = sort(d);
    b = btemp(I);
    count = zeros(1, length(d));
    c = 0;
    for j = I'
        c = c+1;
        count(c) = length(find(d -d(j)>=0 & b < d(j)));
    end
    d = [min(b) min(b) d1' d1(end)];
    count = [0 count(1) count 0];
    if (max(count(:))>maxc)
        maxc = max(count(:));
    end
    plot(d, count);
    hold on;
end
axis([0 max(deaths(:)) 0 maxc])
set(findall(gca, 'Type', 'Line'),'LineWidth',2);
set(gca,'FontSize',20)
end